' Full Power Toolbox/Console Compiler

' Demonstration Program (Version 1.01)

' Copyright 1992 - 2003 Information Management Systems, Inc.


' ----- Modifications Log -----
' 07/16/98 ACE: Added "press any key" on missing FPTOOLS.LST so people who
'   are running the demo from Explorer will see the error message.  Changed
'   code to save current cursor position, not screen size.  Forced cursor on
'   upon exit from program.
' 09/23/98 ACE: Changed INKEY$ to WAITKEY$ for efficiency.
' 09/11/99 ACE: Changed description of operation of SelectorCalendar.
'   Changed company contact info on opening screen.
' 11/25/99 ACE: Changed the Directory Pick List demo to include the short
'   name of each file.  Changed the size of FileMask in same routine.
' 11/27/99 ACE: Changed the size of the FileMask in File Viewer demo.
' 12/06/02 ACE: Changed the path to WIN32API.INC for PBCC 3.
' 03/03/03 ACE: Changed copyright date and company contact information.
' 06/06/03 ACE: Added code to resize the screen before using the tools and
'   restore the screen size upon exit.
' --- End Modifications Log ---


' This demonstration program uses many of the functions and procedures in
' the Full Power Toolbox to show off the capabilities of the product.

' This program is also a good source of working examples of the routines
' in the library.


$INCLUDE "C:\PBCC30\WINAPI\WIN32API.INC"        ' you may need to change this path
$INCLUDE "fptbx.dcl"
$INCLUDE "fpcommon.bas"
$INCLUDE "fpwindow.bas"
$INCLUDE "fppcklst.bas"
$INCLUDE "fpmplist.bas"
$INCLUDE "fpentry.bas"
$INCLUDE "fpentscr.bas"
$INCLUDE "fpviewer.bas"
$INCLUDE "fpmpli-m.bas"
$INCLUDE "fppckl-m.bas"
$INCLUDE "fpbarm-m.bas"
$INCLUDE "fpboxm-m.bas"
$INCLUDE "fpdate.bas"
$INCLUDE "fpcalndr.bas"
$INCLUDE "fpdialog.bas"
$INCLUDE "fpdial-m.bas"
$INCLUDE "fpintrnl.bas"
$INCLUDE "fpconvrt.bas"
$INCLUDE "fpoutput.bas"
$INCLUDE "fpview-m.bas"
$INCLUDE "fpscreen.bas"
$INCLUDE "fpdir-m.bas"
$INCLUDE "fpdirect.bas"
$INCLUDE "fpstring.bas"
$INCLUDE "fpdirspt.bas"

GLOBAL Buttons%, Picker$(), Selected%()

FUNCTION PBMAIN
  ' Check for existence of FPTools.LST
  IF LEN(DIR$("FPTools.LST")) = 0 THEN
    PRINT "Unable to find FPTools.LST.  Please make sure it is in the default directory."
    PRINT "(This file is included with this demo program and is used in some of the"
    PRINT "routine demonstrations, so it is required to use this program.)
    PRINT
    PRINT "Press any key to exit."
    WAITKEY$
    EXIT FUNCTION
  END IF

  ' Main Program Initialization
  DIM OriginalX AS LONG, OriginalY AS LONG
  OriginalX = SCREENX  ' get and store the size of the current screen window
  OriginalY = SCREENY
  StartCursorRow% = CURSORY    ' save the cursor position as well
  StartCursorCol% = CURSORX
  StartScreen& = SaveScreen()  ' save the initial screen
  CONSOLE SCREEN 25,80  ' resize the console window
  SLEEP 250  ' wait to make sure Windows has time to resize the screen
  MOUSE 3, UP  ' initialize the mouse
  MOUSE ON

  ' Array Initialization
  DIM MenuChoice$(1:14), Keys?(1:14), Help$(1:14), Disabled?(1:14)
  DIM ExitBox$(1:3), Picker$(1:45), SampleBox$(1:8), Selected%(1:45)

  ' Demo Control Variables
  ExitDemo& = %False
  ' MenuChoice$() holds the Box Menu line entries, Keys?() holds the menu key
  ' letters, Help$() holds the line help for the main box menu

  MenuChoice$(1)  = "Bar Menu"        : Keys?(1)  = 2  : Help$(1)  = "Sample Bar Menu"
  MenuChoice$(2)  = "Box Menu"        : Keys?(2)  = 1  : Help$(2)  = "Sample Box Menu (you're using a Box Menu now)"
  MenuChoice$(3)  = "Calendars"       : Keys?(3)  = 1  : Help$(3)  = "Calendars and Date Selection"
  MenuChoice$(4)  = "Conversion Tools"    : Keys?(4)  = 3  : Help$(4)  = "Conversion Tools"
  MenuChoice$(5)  = "Data Entry"      : Keys?(5)  = 6  : Help$(5)  = "Individual Data Entry Fields and Data Entry Screens"
  MenuChoice$(6)  = "Date Tools"      : Keys?(6)  = 1  : Help$(6)  = "Date Tools"
  MenuChoice$(7)  = "Dialog Boxes"    : Keys?(7)  = 6  : Help$(7)  = "Sample Dialog Box"
  MenuChoice$(8)  = "Directory Pick List"     : Keys?(8)  = 16 : Help$(8)  = "Choose a File from a Pick List"
  MenuChoice$(9)  = "File Viewer"     : Keys?(9) = 6   : Help$(9) = "View a File"
  MenuChoice$(10) = "Internal Tools"  : Keys?(10) = 1  : Help$(10) = "DOS and BIOS Internal Tools"
  MenuChoice$(11) = "Multi-Pick Pick List": Keys?(11) = 1  : Help$(11) = "Use a Multiple-Pick Pick List"
  MenuChoice$(12) = "Pick List"       : Keys?(12) = 1  : Help$(12) = "Use a Pick List"
  MenuChoice$(13) = "Screen Tools"    : Keys?(13) = 1  : Help$(13) = "Fancy Screen Handling Tools"
  MenuChoice$(14) = "Windowing Tools" : Keys?(14) = 1  : Help$(14) = "Powerful Windowing Tools"
  FOR c& = 1 TO 14
    Disabled?(c&) = 0
  NEXT c&

  ExitBox$(1) = "Are you sure you want to quit?"  ' a Dialog Box message
  ExitBox$(2) = ""
  ExitBox$(3) = "Press Y or Esc to Quit, any other key to continue."
  DIM ExBox AS WinAttr    ' create an instance of the WinAttr type for use by the exit dialog box
  ' the UR, UC, LR, and LC fields are left set to 0 to force dynamic sizing
  ExBox.Style = 1         ' single line frame
  ExBox.Title = 2         ' title is centered on top line
  ExBox.Shade = 2         ' shadow drops down and to the right
  ExBox.Shd = &H07    ' white on black shadow
  ExBox.Win = &H1F    ' bright white on blue interior
  ExBox.Frm = &H1E    ' yellow on blue frame
  ExBox.Ttl = &H1B    ' light cyan on blue title

  SampleBox$(1) = "This is a sample Dialog Box.  The box frame is"
  SampleBox$(2) = "dynamically sized to accomodate the longest line"
  SampleBox$(3) = "in the message.  Each line is centered within the"
  SampleBox$(4) = "box, and the box may be automatically centered on"
  SampleBox$(5) = "the screen or placed in a specific location."
  SampleBox$(6) = ""
  SampleBox$(7) = "You can even include blank lines and any ASCII"
  SampleBox$(8) = "character (like " + CHR$(240) + ") in your message."

  Picker$(1)  = "Elephant"    : Picker$(16) = "Cougar"    : Picker$(31) = "Falcon"
  Picker$(2)  = "Cow"         : Picker$(17) = "Wolverine" : Picker$(32) = "Chicken"
  Picker$(3)  = "Pig"         : Picker$(18) = "Otter"     : Picker$(33) = "Sheep"
  Picker$(4)  = "Horse"       : Picker$(19) = "Wildebeast": Picker$(34) = "Aardvark"
  Picker$(5)  = "Hippopotamus": Picker$(20) = "Antelope"  : Picker$(35) = "Toucan"
  Picker$(6)  = "Giraffe"     : Picker$(21) = "Gazelle"   : Picker$(36) = "Kiwi"
  Picker$(7)  = "Beaver"      : Picker$(22) = "Squirrel"  : Picker$(37) = "Gnu"
  Picker$(8)  = "Woodpecker"  : Picker$(23) = "Hawk"      : Picker$(38) = "Shark"
  Picker$(9)  = "Cat"         : Picker$(24) = "Eagle"     : Picker$(39) = "Whale"
  Picker$(10) = "Dog"         : Picker$(25) = "Ocelot"    : Picker$(40) = "Dolphin"
  Picker$(11) = "Lion"        : Picker$(26) = "Chipmunk"  : Picker$(41) = "Hamster"
  Picker$(12) = "Tiger"       : Picker$(27) = "Fox"       : Picker$(42) = "Mouse"
  Picker$(13) = "Panther"     : Picker$(28) = "Weasel"    : Picker$(43) = "Rat"
  Picker$(14) = "Rhinocerous" : Picker$(29) = "Lizard"    : Picker$(44) = "Ferret"
  Picker$(15) = "Leopard"     : Picker$(30) = "Goat"      : Picker$(45) = "Guinea Pig"

  ' Display the Opening Screen
  COLOR 15, 7  ' use a bright white on white screen
  CLS

  ' draw a frame on the screen, surrounded by a shadow
  DIM Box AS WinAttr  ' create an instance of the WinAttr type
  Box.UR = 2  ' the frame goes from row 2, column 2
  Box.UC = 4
  Box.LR = 23     ' to row 23, column 78
  Box.LC = 76
  Box.Style = 4   ' use a fancy frame
  Box.Title = 2   ' title goes on top line, centered
  Box.Btn = 0     ' no "close window" button
  Box.Shade = 6   ' thin shadow, down and to the right
  Box.Shd = &H70  ' black on white shadow
  Box.Win = &H1F  ' bright white on blue interior
  Box.Frm = &H1E  ' yellow on blue frame
  Box.Ttl = &H1B  ' light cyan on blue title
  Title$ = "Demonstration Program"    ' the title for the frame
  CALL OpenWindow(Box, Title$, Save&)     ' open a window on the screen
  COLOR 12,1  ' the name of the product goes in bright red on blue
  LOCATE 4, 1
  CALL CenterPrint("The Full Power Toolbox/Console Compiler Edition", 80)
  COLOR 15,1   ' the rest of the screen goes in bright white on blue
  LOCATE 5, 1
  CALL CenterPrint("Version 1.01", 80)
  LOCATE 7, 1
  CALL CenterPrint("Demonstration Program", 80)
  LOCATE 10, 1
  CALL CenterPrint("Copyright 1992 - 2003 Information Management Systems, Inc.", 80)
  LOCATE 11,1
  CALL CenterPrint("All rights reserved.", 80)
  LOCATE 14, 1
  CALL CenterPrint("Information Management Systems, Inc.", 80)
  LOCATE 15, 1
  CALL CenterPrint("320 Village Walk Dr.", 80)
  LOCATE 16, 1
  CALL CenterPrint("Macungie, PA  18062-1137", 80)
  LOCATE 17, 1
  CALL CenterPrint("(800) 750-6390 (Sales)", 80)
  LOCATE 18, 1
  CALL CenterPrint("(610) 966-5511 (Support)", 80)
  LOCATE 19, 1
  CALL CenterPrint("(610) 966-6981 (Fax)", 80)
  LOCATE 20, 1
  CALL CenterPrint("http://www.infoms.com", 80)
  LOCATE 22, 1
  CALL CenterPrint("Press any key to begin the demonstration.", 80)

  WAITKEY$    ' wait for a keystroke

  ' Main Program

  DIM MBox AS WinAttr     ' create an instance of the WinAttr type for the main menu
  MBox.UR = 2     ' box menu starts at row 2, column 28
  MBox.UC = 28    ' and is dynamically sized for the other coordinates
  MBox.Style = 3  ' use a fancy frame
  MBox.Title = 2  ' center the title on the top line
  MBox.Shade = 2  ' thick shadow down and to the right
  MBox.Shd = &H07     ' white on black shadow
  MBox.Win = &H1F     ' bright white on blue interior
  MBox.Frm = &H1E     ' yellow on blue frame
  MBox.Ttl = &H1B     ' light cyan on blue title
  MTitle$ = "Demo Main Menu"
  HelpRow? = 25   ' display help messages on the bottom row of the screen
  KeyAttr? = &H1E     ' yellow on blue key letters
  DisAttr? = &H10     ' black on blue disabled menu items
  HelpAttr? = &H7F    ' bright white on white help messages
  HighAttr? = &H71    ' blue on white highlight bar

  DIM HBox AS WinAttr ' create an instance of the WinAttr type for the help system
  HBox.UR = 5     ' help window is at row 5, column 5
  HBox.UC = 5
  HBox.LR = 20    ' and extends to row 20
  HBox.Style = 1  ' single line frame
  HBox.Title = 2  ' center the title on the top line
  HBox.Shade = 2  ' thick shadow down and to the right
  HBox.Shd = &H07 ' white on black shadow
  HBox.Win = &H1F ' bright white on blue interior
  HBox.Frm = &H1E ' yellow on blue frame
  HBox.Ttl = &H1B ' light cyan on blue title

  DO  ' main program loop
    COLOR 0, 7  ' black on white screen
    CLS
    IF Selected% >= 0 THEN    ' only do this if the user had been on a menu item (rather than pressing Esc and saying No when asked to confirm)
      Initial? = Selected%    ' start with the highlight bar on the last selected menu item
      IF Initial? = 0 THEN Initial? = 1   ' this is our first trip to the menu, so start on the first item
    END IF
    Selected% = BoxMenuM%(MenuChoice$(), Keys?(), Help$(), Disabled?(), Initial?, MBox, MTitle$, HelpRow?, KeyAttr?, DisAttr?, HelpAttr?, HighAttr?)

    SELECT CASE Selected%         ' evaluate selected Box Menu option
      CASE -1     ' user pressed Esc
        Quit$ = DialogBox$(ExitBox$(), ExBox, "Confirm Quitting")
        IF INSTR(Quit$, ANY "Yy" + CHR$(27)) THEN ExitDemo& = %True   ' user pressed Y, y, or Esc
      CASE 1  ' Bar Menu
        CALL BarDemo
      CASE 2  ' Box Menu
        CALL BoxDemo
      CASE 3  ' Calendars
        CALL CalendarDemo
      CASE 4  ' Conversion Tool
        CALL Convert
      CASE 5  ' Data Entry
        CALL DataEntry
      CASE 6  ' Date Tools
        CALL DateDemo
      CASE 7  ' Dialog Box
        x$ = DialogBoxM$(SampleBox$(), ExBox, "Sample Dialog Box", 0)
      CASE 8  ' Directory Pick List
        CALL Direct
      CASE 9  ' File Viewer
        CALL Viewer
      CASE 10     ' Internal Tools
        CALL InternalDemo
      CASE 11     ' Multi-Pick Pick List
        CALL MultiPick
      CASE 12     ' Pick List
        CALL PickDemo
      CASE 13     ' Screen Tools
        CALL ScreenDemo
      CASE 14     ' Windowing Tools
        CALL WindowDemo
    END SELECT
  LOOP UNTIL ExitDemo&    ' user pressed Esc

  ' Exit Demo program
  COLOR 7,0    ' default DOS colors (white on black)
  CONSOLE SCREEN OriginalY, OriginalX  ' reset the screen to its original size
  CALL RestoreScreen(StartScreen&)    ' restore the original DOS screen
  LOCATE StartCursorRow%, StartCursorCol%     ' place the cursor at the original location
  CURSOR ON
  PRINT
  PRINT "Thank you for your interest in the Full Power Toolbox!"
  PRINT
  PRINT "For a complete list of the functions and procedures in the Full Power"
  PRINT "Toolbox, please refer to the file FPTools.LST."

END FUNCTION    ' end of demo program



' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

' Supplemental Procedures (called by the SELECT CASE in response to the
' specific demo selected from the main Box Menu).

' These procedures call the actual tools from the Full Power Toolbox/Console Compiler.

' =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


SUB BarDemo LOCAL
  COLOR 0,7
  CLS
  LOCATE 16,1
  PRINT "  One of the two menu systems included in the Full Power Toolbox is the Bar"
  PRINT "  Menu Unit.  It displays dynamic bar menus, complete with key letter"
  PRINT "  selection and help messages attached to each menu choice.  As the"
  PRINT "  highlight bar is positioned on a choice, the help message is displayed"
  PRINT "  on the line of your choice.  (Of course, the help messages may be turned"
  PRINT "  off.)  The Run menu option has been disabled for this example."
  PRINT
  PRINT "  This bar menu is similar to the one in the PowerBASIC/DOS IDE."

  DIM Choices$(1:7), Keys?(1:7), Help$(1:7), Disabled?(1:7)
  Choices$(1) = "File"    : Keys?(1) = 1 : Help$(1) = "File menu (save, shell, print, etc.)"
  Choices$(2) = "Edit"    : Keys?(2) = 1 : Help$(2) = "Editing menu (cut, copy, paste, etc.)"
  Choices$(3) = "Search"  : Keys?(3) = 1 : Help$(3) = "Search menu (find, replace, repeat search, etc.)"
  Choices$(4) = "Run"     : Keys?(4) = 1 : Help$(4) = "Run menu (run, trace into, reset program, etc.)"
  Choices$(5) = "Compile" : Keys?(5) = 1 : Help$(5) = "Compile menu (compile, find error, get info, etc.)"
  Choices$(6) = "Options" : Keys?(6) = 1 : Help$(6) = "IDE Options menu (compiler, linker, directories, etc.)"
  Choices$(7) = "Debug"   : Keys?(7) = 1 : Help$(7) = "Debug menu (evaluate, watches, break points, etc.)"
  Disabled?(4) = 1  ' disable the Run menu
  Row? = 1  ' display menu on top line of screen
  HelpRow? = 25     ' display help messages on bottom line (when HelpRow? = 0, the help messages are not displayed)
  BarAttr? = &H5E   ' yellow on magenta highlight bar
  MenuAttr? = &H1E  ' yellow on blue menu bar
  KeyAttr? = &H1B   ' light cyan on blue key letters
  DisAttr? = &H10   ' black on blue disabled menu items
  HelpAttr? = &H71  ' blue on white help messages
  DO
    IF Selected% THEN Initial? = Selected% ELSE Initial? = 1
    Selected% = BarMenuM%(Choices$(), Keys?(), Help$(), Disabled?(), Row?, HelpRow?, Initial?, BarAttr?, MenuAttr?, KeyAttr?, DisAttr?, HelpAttr?)
    IF Selected% = -1 THEN EXIT LOOP    ' user pressed Esc
    LOCATE 10,1
    PRINT SPACE$(70);   ' erase previous message
    LOCATE 10,1
    PRINT "You selected "; Choices$(Selected%);
  LOOP
  ERASE Choices$(), Keys?(), Help$(), Disabled?()
END SUB


SUB BoxDemo LOCAL
  COLOR 0,7
  CLS
  LOCATE 16,1
  PRINT "  One of the two menu systems included in the Full Power Toolbox is the Box"
  PRINT "  Menu Unit.  It displays dynamic box menus, complete with key letter"
  PRINT "  selection and help messages attached to each menu choice.  As the"
  PRINT "  highlight bar is positioned on a choice, the help message is displayed"
  PRINT "  on the line of your choice.  (Of course, the help messages may be turned"
  PRINT "  off.)  The Run menu option has been disabled for this example."
  PRINT
  PRINT "  This box menu has similar choices to the menu in the PowerBASIC/DOS IDE."

  DIM Choices$(1:7), Keys?(1:7), Help$(1:7), Disabled?(1:7)
  Choices$(1) = "File Menu"    : Keys?(1) = 1 : Help$(1) = "File menu (save, shell, print, etc.)"
  Choices$(2) = "Edit Menu"    : Keys?(2) = 1 : Help$(2) = "Editing menu (cut, copy, paste, etc.)"
  Choices$(3) = "Search Menu"  : Keys?(3) = 1 : Help$(3) = "Search menu (find, replace, repeat search, etc.)"
  Choices$(4) = "Run Menu"     : Keys?(4) = 1 : Help$(4) = "Run menu (run, trace into, reset program, etc.)"
  Choices$(5) = "Compile Menu" : Keys?(5) = 1 : Help$(5) = "Compile menu (compile, find error, get info, etc.)"
  Choices$(6) = "Options Menu" : Keys?(6) = 1 : Help$(6) = "IDE Options menu (compiler, linker, directories, etc.)"
  Choices$(7) = "Debug Menu"   : Keys?(7) = 1 : Help$(7) = "Debug menu (evaluate, watches, break points, etc.)"
  Disabled?(4) = 1  ' disable the Run menu
  DIM Box AS LOCAL WinAttr  ' create a local instance of the WinAttr type
  Box.UR = 5
  Box.UC = 10
  Box.Style = 15    ' thin/thick line frame
  Box.Title = 2         ' title goes on top line, centered
  Box.Shade = 6         ' thin shadow, down and to the right
  Box.Shd = &H70    ' black on white shadow
  Box.Win = &H1F    ' bright white on blue interior
  Box.Frm = &H1E    ' yellow on blue frame
  Box.Ttl = &H1B    ' light cyan on blue title
  Title$ = "Box Menu"
  HelpRow? = 25         ' display help messages on bottom line (when HelpRow? = 0, the help messages are not displayed)
  HighAttr? = &H5E  ' yellow on magenta highlight bar
  KeyAttr? = &H1B   ' light cyan on blue key letters
  DisAttr? = &H10   ' black on blue disabled menu items
  HelpAttr? = &H71  ' blue on white help messages

  DO
    IF Selected% THEN Initial? = Selected% ELSE Initial? = 1
    Selected% = BoxMenuM%(Choices$(), Keys?(), Help$(), Disabled?(), Initial?, Box, Title$, HelpRow?, KeyAttr?, DisAttr?, HelpAttr?, HighAttr?)
    IF Selected% = -1 THEN EXIT LOOP    ' user pressed Esc
    LOCATE 1,1
    PRINT SPACE$(70);   ' erase previous message
    LOCATE 1,1
    PRINT "You selected "; Choices$(Selected%);
  LOOP
  ERASE Choices$(), Keys?(), Help$(), Disabled?()
END SUB


SUB CalendarDemo LOCAL
  COLOR 0,7
  CLS
  ' place this month's calendar in the upper lefthand corner of the screen
  Row? = 2
  Col? = 2
  CALL SeparateDate(DATE$, Month?, Day?, Year%)     ' get the components of the system date
  Title% = -1   ' display the month and year
  DayLine% = -1     ' display the day line
  CalAttr? = &H71   ' blue on white calendar
  CurAttr? = &H74   ' system date is red on white
  CALL Calendar(Row?, Col?, Month?, Year%, Title%, DayLine%, CalAttr?, CurAttr?)
  COLOR 0,7
  LOCATE 3,26
  PRINT "This calendar block is for the current month."
  LOCATE 4,26
  PRINT "It was displayed by the Calendar procedure."

  ' now display a scrolling calendar
  LOCATE 14,26
  PRINT "This calendar is a scrolling calendar.  It allows you"
  LOCATE 15,26
  PRINT "to change the month and year that are displayed.  To"
  LOCATE 16,26
  PRINT "change the month, press the Right or Left Arrow key;"
  LOCATE 17,26
  PRINT "to change the year, press the PgUp or PgDn key.  To"
  LOCATE 18,26
  PRINT "exit this calendar, press the Esc key."
  Row? = 12
  Col? = 2
  CALL ScrollingCalendar(Row?, Col?, Month?, Year%, DayLine%, Title%, CalAttr?, CurAttr?, EMonth?, EYear%)

  ' now display a selector calendar
  COLOR 0,7
  CLS
  LOCATE 14,26
  PRINT "This calendar is a selector calendar.  It allows you"
  LOCATE 15,26
  PRINT "to select a specific day from the calendar.  Use the"
  LOCATE 16,26
  PRINT "cursor keys to move the selector around the calendar."
  LOCATE 17,26
  PRINT "To change the month, press the + or - key; to change"
  LOCATE 18,26
  PRINT "the year, press the PgUp or PgDn key.  To select the"
  LOCATE 19,26
  PRINT "highlighted date, press the Enter key.  To exit this"
  LOCATE 20,26
  PRINT "calendar, press the Esc key."
  Row? = 12
  Col? = 2
  SelAttr? = &H17   ' white on blue selector box
  DO
    CALL SelectorCalendar(Row?, Col?, Month?, Day?, Year%, DayLine%, Title%, CalAttr?, CurAttr?, SelAttr?, EMonth?, EDay?, EYear%)
    IF EDay? = 0 THEN EXIT LOOP
    COLOR 0,7
    LOCATE 24,1
    PRINT "You selected "; CreateDate$(EMonth?, EDay?, EYear%);
    Month? = EMonth?    ' copy the ending date into the starting date
    Day? = EDay?
    Year% = EYear%
  LOOP
END SUB


SUB Convert LOCAL
  COLOR 0,7
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox can convert numbers into their word equivalents."
  PRINT "  For example, 132 becomes `one hundred thirty-two'.  Try it now!"
  DIM Fld AS LOCAL FieldEdit    ' create an instance of the FieldEdit type
  Fld.Row = 6   ' put the field at row 6, column 5
  Fld.Col = 5
  Fld.Length = 6    ' accept up to 6 characters
  Fld.Valid = 3         ' signed numeric
  Fld.Mode = 3
  Fld.Echo = -1         ' echo characters as typed
  Fld.PAttr = &H71  ' blue on white prompt
  Fld.EAttr = &H4F  ' bright white on red field
  Fld.DAttr = &H71  ' blue on white field upon exit
  Prompt$ = "Enter a Number: "
  ExitKeys$ = CHR$(13,27)   ' Enter and Esc are exit keys
  CCursor? = 0       ' cursor starts at left edge of field
  InsertMode% = -1  ' insert mode is on
  ' present a data entry field for the user
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, CCursor?, InsertMode%)
  IF ASC(Chk$) = 27 THEN EXIT SUB     ' user pressed Esc
  Operand& = VAL(Entry$)
  COLOR %BLUE, %WHITE
  LOCATE 8,5
  PRINT NumberToWords$(Operand&)
  LOCATE 11,1
  COLOR 0
  PRINT "  The Toolbox can also convert temperatures between Fahrenheit, Celsius,"
  PRINT "  and Kelvin.  Enter a Fahrenheit temperature now."
  Fld.Row = 14  ' put the field at row 14, column 5 (column already set)
  Fld.Valid = 4         ' signed floating point numeric
  Fld.Mode = 3
  Prompt$ = "Enter a Temperature: "
  Entry$ = ""
  CCursor? = 0       ' cursor starts at left edge of field
  ' present a data entry field for the user
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, CCursor?, InsertMode%)
  IF ASC(Chk$) = 27 THEN EXIT SUB     ' user pressed Esc
  Temper# = VAL(Entry$)
  COLOR %BLUE
  LOCATE 16,5
  PRINT "Celsius equivalent:"; FahrToCels#(Temper#)
  PRINT "     Kelvin equivalent:"; FahrToKelv#(Temper#)
  PRINT
  COLOR 0
  PRINT "  Press any key to return to the menu."
  WAITKEY$  ' wait for a keystroke
END SUB


SUB DataEntry LOCAL
  COLOR 0,7
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox includes four powerful and flexible data entry"
  PRINT "  routines.  The individual data entry routines have been used throughout"
  PRINT "  this demo, whenever you have been asked to enter any kind of information."
  PRINT "  This screen contains several data entry fields, managed by the"
  PRINT "  EntryScreen function.  To return to the menu, press the Esc or F10 key."
  DIM Fld(1:8) AS LOCAL FieldEdit
  DIM Prompt$(1:8), FieldData$(1:8), Mask$(1:8)
  Prompt$(1) = "Enter your name, address, and phone number."
  Prompt$(2) = "First Name: "
  Prompt$(3) = "Last Name: "
  Prompt$(4) = "Address: "
  Prompt$(5) = "City: "
  Prompt$(6) = "State: "    ' no other masks are used, so none others are specified
  Prompt$(7) = "Zip Code: "     : Mask$(7) = CHR$(1,1,1,1,1) + "-" + CHR$(1,1,1,1)
  Prompt$(8) = "Phone Number: " : Mask$(8) = "(" + CHR$(1,1,1) + ") " + CHR$(1,1,1) + "-" + CHR$(1,1,1,1)
  FOR c% = 1 TO 8   ' cycle through the fields to set basic parameters
    Fld(c%).Row = c% + 9    ' most fields start at this calculated row
    Fld(c%).Col = 3         ' most fields start at column 3
    Fld(c%).Valid = 8       ' any characters may be entered
    Fld(c%).Mode = 4        ' normal editing; cursor may pass end of field
    Fld(c%).Echo = -1       ' echo characters as they are entered
    Fld(c%).PAttr = &H71    ' blue on white prompts
    Fld(c%).DAttr = &H74    ' red on white data after editing field
    Fld(c%).EAttr = &H0B    ' light cyan on black while editing
  NEXT c%
  Fld(1).Row = 9    ' label field is on row 7
  Fld(6).Row = 14   ' state and zip code are on row 13
  Fld(7).Row = 14
  Fld(8).Row = 15   ' phone number is on row 14
  Fld(6).Col = 31   ' state field is at column 31
  Fld(7).Col = 42   ' zip code field is at column 42
  Fld(2).Length = 10    ' first name is 10 characters long
  Fld(3).Length = 15    ' last name is 15 characters long
  Fld(4).Length = 30    ' address is 30 characters long
  Fld(5).Length = 20    ' city is 20 characters long
  Fld(6).Length = 2     ' state abbreviation is 2 characters long
  Fld(1).Valid = 255    ' the first field is a label only field
  Fld(6).Valid = 6  ' state is alphabetic; force to all caps
  Fld(7).Valid = 9  ' zip code is a masked entry field
  Fld(8).Valid = 9  ' phone number is a masked entry field
  Fld(6).Mode = 6   ' normal editing; exit when cursor reaches end of field
  Fld(7).Mode = 6   ' normal editing; exit when cursor reaches end of field
  Fld(8).Mode = 6   ' normal editing; exit when cursor reaches end of field
  StartField% = 2   ' start on the first name field
  MainExit$ = CHR$(27,0,68)     ' exit keys are Esc and F10
  Repaint% = -1         ' cause the fields to be redrawn upon entry
  InsertMode% = -1  ' start with Insert Mode turned on
  Chk$ = EntryScreen$(Fld(), Prompt$(), FieldData$(), Mask$(), StartField%, MainExit$, Repaint%, InsertMode%, Modified%)
  IF ASC(Chk$) = 27 THEN EndDataEntryDemo
  COLOR %BLUE, %WHITE
  LOCATE 18,1
  PRINT "  You pressed F10 to exit the entry screen."
  IF Modified% THEN
    PRINT "  You entered data in at least one field."   ' we could check Fld().Change and see which individual fields were modified
  ELSE
    PRINT "  You did not enter data in any fields."
  END IF
  PRINT
  PRINT "  Press any key to return to the menu."
  WAITKEY$  ' wait for a keystroke

  EndDataEntryDemo:     ' jump here upon Esc to erase arrays and return to menu
    ERASE Fld(), Prompt$(), FieldData$(), Mask$()
END SUB


SUB DateDemo LOCAL
  COLOR 0,7
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox contains an array of Date and Time manipulation"
  PRINT "  tools.  Using the Toolbox's functions and procedures, this program will"
  PRINT "  manipulate the date and time that you enter."
  DIM Fld AS LOCAL FieldEdit    ' create an instance of the FieldEdit type
  Fld.Row = 7   ' put the field at row 7, column 5
  Fld.Col = 5
  Fld.Mode = 3
  Fld.Echo = -1         ' echo characters as typed
  Fld.PAttr = &H71  ' blue on white prompt
  Fld.EAttr = &H4F  ' bright white on red field
  Fld.DAttr = &H71  ' blue on white field upon exit
  Prompt$ = "Enter your birthdate: "    ' prompt for the field
  Mask$ = CHR$(1,1) + "/" + CHR$(1,1) + "/19" + CHR$(1,1)   ' field looks like "00/00/1900"
  ExitKeys$ = CHR$(13,27)   ' Enter and Esc are exit keys
  Chk$ = MaskedEntry$(Fld, Prompt$, Mask$, Entry$, ExitKeys$)
  IF ASC(Chk$) = 27 THEN EXIT SUB     ' user pressed Esc
  ' print the birthdate in all available formats
  LOCATE 9,1
  COLOR %BLUE, %WHITE
  PRINT "  Dates can be formatted in each of these ways:"
  PRINT
  FOR Format? = 1 TO 12
    IF Format? > 8 THEN Separator$ = " " ELSE Separator$ = "/"
    PRINT TAB(5) FormatDate$(Entry$, Format?, Separator$)
  NEXT Format?
  PRINT
  PRINT "  Press any key to continue."
  WAITKEY$  ' wait for a keystroke
  COLOR 0,7
  CLS
  LOCATE 3,3
  PRINT "The Julian number of your birthdate is"; JulianNumber&(Entry$)
  PRINT "  You were born on a "; DayWeek$(Entry$)
  PRINT "  You are"; ABS(ElapsedDays&(Entry$, DATE$)); "days old."
  PRINT
  PRINT
  PRINT "  The Toolbox can perform other manipulations as well, such as adding"
  PRINT "  or subtracting days from a date to get a new day."
  Fld.Row = 13  ' put the field at row 13, column 5
  Fld.Length = 4    ' accept up to 4 digits
  Fld.Valid = 3         ' signed numeric
  Prompt$ = "Number of Days: "
  CCursor? = 0       ' cursor starts at left edge of field
  InsertMode% = -1  ' insert mode is on
  Entry$ = ""
  ' present a data entry field for the user
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, CCursor?, InsertMode%)
  IF ASC(Chk$) = 27 THEN EXIT SUB     ' user pressed Esc
  Operand% = VAL(Entry$)
  LOCATE 15,3
  COLOR %BLUE, %WHITE
  PRINT "The date, in"; Operand%; "days, will be (or was): "; IncrDate$(DATE$, Operand%)
  PRINT
  PRINT "  Press any key to continue."
  WAITKEY$  ' wait for a keystroke
  ' now try the time tools
  COLOR 0,7
  CLS
  Fld.Row = 3   ' put the field at row 3, column 3
  Fld.Col = 3
  Prompt$ = "Now enter a time (in HH:MM:SS military format): "
  Mask$ = CHR$(1,1) + ":" + CHR$(1,1) + ":" + CHR$(1,1) + "." + CHR$(1,1)   ' field looks like "00:00:00.00"
  Entry$ = ""
  Chk$ = MaskedEntry$(Fld, Prompt$, Mask$, Entry$, ExitKeys$)
  IF ASC(Chk$) = 27 THEN EXIT SUB     ' user pressed Esc
  LOCATE 5,1
  COLOR %BLUE, %WHITE
  PRINT "  Times can be formatted in each of these ways:"
  PRINT
  FOR Format? = 1 TO 3
    PRINT TAB(5) FormatTime$(Entry$, Format?, 0, 0)
    PRINT TAB(5) FormatTime$(Entry$, Format?, 1, 0)
    PRINT TAB(5) FormatTime$(Entry$, Format?, 0, 1)
    PRINT TAB(5) FormatTime$(Entry$, Format?, 1, 1)
  NEXT Format?
  PRINT
  PRINT "  That time occurred"; TimeToSeconds!(Entry$); "seconds after midnight."
  PRINT "  The elapsed time between that time and the current time is "; ElapsedTime$(Entry$, TIME$)
  PRINT
  PRINT "  Press any key to return to the menu."
  WAITKEY$  ' wait for a keystroke
END SUB


SUB Direct
  COLOR 0,7
  CLS
  LOCATE 3,1
  PRINT "  This tool creates a Pick List of the files from a directory with a"
  PRINT "  given file specifier (such as *.TXT).  This demonstration will now"
  PRINT "  create a list of all the normal and read-only files in the current"
  PRINT "  directory.  The name of the file you select will be displayed at the"
  PRINT "  bottom of the screen.  To return to the menu, press the Esc key or"
  PRINT "  click the right mouse button."

  DIM Box AS LOCAL WinAttr  ' create an instance of the WinAttr type for the directory pick list
  DIM FileMask AS ASCIIZ * 128
  Box.UR = 10   ' the upper corner of the box is at row 10, column 34
  Box.UC = 10
  Box.LR = 22   ' the lower row is 22; the width is sized dynamically
  Box.Style = 2     ' double line box frame
  Box.Title = 2     ' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07    ' white on black shadow
  Box.Win = &H1F    ' bright white on blue interior
  Box.Frm = &H1E    ' yellow on blue frame
  Box.Ttl = &H1B    ' light cyan on blue title
  SScroll? = 1      ' show the scroll bar
  FileMask = "*.*"
  FileAttrib% = 0   ' ignored in Win32
  FileList? = &B111111  ' display all info in the list
  Separ$ = CHR$(179)    ' use the vertical bar as a separator
  HighAttr? = &H71  ' blue on white highlight bar
  DO
    File$ = DirectoryPickM$(Box, "Files", SScroll?, FileMask, FileAttrib%, FileList?, Separ$, HighAttr?, 15)
    LOCATE 25,2
    COLOR 0,7
    PRINT "File selected: "; File$; SPACE$(20);
  LOOP WHILE LEN(File$)
END SUB


SUB Viewer           ' file viewer demo
  COLOR 0,7
  CLS
  ' display the directory pick list for the user
  DIM Box AS LOCAL WinAttr  ' create an instance of the WinAttr type for the directory pick list
  DIM FileMask AS ASCIIZ * 128
  Box.UR = 3    ' the upper corner of the box is at row 10, column 34
  Box.UC = 15
  Box.LR = 22   ' the lower row is 22; the width is sized dynamically
  Box.Style = 2     ' double line box frame
  Box.Title = 2     ' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07    ' white on black shadow
  Box.Win = &H1F    ' bright white on blue interior
  Box.Frm = &H1E    ' yellow on blue frame
  Box.Ttl = &H1B    ' light cyan on blue title
  Title$ = "Select a File to View"
  SScroll? = 1       ' show the scroll bar
  FileMask = "*.*"
  FileAttrib% = 0   ' ignored in Win32
  FileList? = &B11111   ' display all info in the list
  Separ$ = CHR$(179)    ' use the vertical bar as a separator
  HighAttr? = &H71  ' blue on white highlight bar
  File$ = DirectoryPickM$(Box, Title$, SScroll?, FileMask, FileAttrib%, FileList?, Separ$, HighAttr?, 15)
  IF LEN(File$) = 0 THEN EXIT SUB
  ' now set up and access the file viewer
  CALL Line25(CHR$(24) + ", " + CHR$(25) + ", PgUp, PgDn, " + CHR$(26) + _
          ", " + CHR$(27) + ", Home, End, Alt-L, Esc to Exit")    ' mini help for the file viewer
  Box.UR = 2
  Box.UC = 2
  Box.LR = 23
  Box.LC = 78
  Box.Style = 1
  Box.Shade = 6
  Box.Shd = &H70
  TabLen% = 8   ' default TAB stop
  SScroll? = 1   ' display a scroll bar
  x% = ViewFileM%(File$, Box, TabLen%, SScroll?)
END SUB


SUB InternalDemo LOCAL
  COLOR 0,7
  CLS
  LOCATE 3,1
  PRINT "  In addition to the high level tools included in the Full Power Toolbox,"
  PRINT "  there are several low level tools, many of which use low level API"
  PRINT "  calls to give your program information and control that PB/CC cannot"
  PRINT "  give you directly."
  PRINT
  COLOR %BLUE, %WHITE
  PRINT
  PRINT "  The name of this program is: "; GetProgramName$
  PRINT
  PRINT "  This program will now check the size of one of your drives."
  DIM Fld AS LOCAL FieldEdit    ' create an instance of the FieldEdit type
  Fld.Row = 18  ' put the field at row 16, column 3
  Fld.Col = 3
  Fld.Length = 1
  Fld.Valid = 6
  Fld.Mode = 3
  Fld.Echo = -1         ' echo characters as typed
  Fld.PAttr = &H71  ' blue on white prompt
  Fld.EAttr = &H4F  ' bright white on red field
  Fld.DAttr = &H71  ' blue on white field upon exit
  Prompt$ = "Enter a drive letter: "
  ExitKeys$ = CHR$(13,27)   ' Enter and Esc are exit keys
  CCursor? = 0   ' start at left edge of field
  InsertMode% = 0   ' overwrite mode
  Chk$ = FieldEntry$(Fld, Prompt$, Entry$, ExitKeys$, CCursor?, InsertMode%)
  IF ASC(Chk$) = 27 THEN EXIT SUB
  DIM Entry2 AS ASCIIZ * 255
  Entry2 = Entry$
  Entry2 = Entry2 + ":\"
  CALL GetFreeSpace(Entry2, ClusterSize???, TotalSpace???, FreeSpace???)
  COLOR %BLUE, %WHITE
  LOCATE 19,1
  IF ClusterSize??? > 0 THEN
    PRINT "    Clusters are"; ClusterSize???; "bytes long."
    PRINT "    Total space available: "; FORMAT$(TotalSpace???,"#,###,###,###"); " bytes."
    PRINT "    Free space available:  "; FORMAT$(FreeSpace???, "#,###,###,###"); " bytes."
  ELSE
    PRINT "    Invalid drive specifier."
  END IF
  PRINT
  PRINT "  Press any key to return to the menu."
  WAITKEY$  ' wait for a keystroke
END SUB


SUB MultiPick LOCAL
  COLOR 0,7
  CLS
  PRINT "  A Multi-Pick Pick List is a very powerful interface tool.  It allows you"
  PRINT "  to present a list of options to the user.  He or she can select all, some,"
  PRINT "  one, or none of the options.  These lists are ideal for selecting multiple"
  PRINT "  database records for inclusion in reports or searches, choosing program"
  PRINT "  configuration options, etc.  Each item in the list can begin selected or"
  PRINT "  unselected; just click on the item with the left mouse button or highlight"
  PRINT "  it and press the Enter key to toggle the selected state.  In addition to"
  PRINT "  the cursor keys, you can type a portion of a word in the list and jump"
  PRINT "  directly to that word.  Give it a try now:"
  DIM Box AS LOCAL WinAttr  ' create an instance of the WinAttr type for the pick list box
  Box.UR = 11   ' the upper corner of the box is at row 11, column 20
  Box.UC = 20
  Box.LR = 22   ' the lower row is 22; the width is sized dynamically
  Box.Style = 1     ' single line box frame
  Box.Title = 2     ' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07    ' white on black shadow
  Box.Win = &H1F    ' bright white on blue interior
  Box.Frm = &H1E    ' yellow on blue frame
  Box.Ttl = &H1B    ' light cyan on blue title
  SortFlag% = 1         ' sort list in ascending order
  Title$ = "Animals"
  SScroll? = 1       ' show the scroll bar
  HighAttr? = &H71  ' blue on white highlight bar
  SelAttr? = &H1E   ' selected items are yellow on blue
  SelKey$ = CHR$(251)   ' use a check mark for selected characters
  DO
    CALL MultiPickListM(Picker$(), Selected%(), SortFlag%, Box, Title$, SScroll?, HighAttr?, SelAttr?, SelKey$)
    COLOR %BLUE, %WHITE
    CLS
    Picked% = 0
    FOR i% = 1 TO 45
      IF Selected%(i%) THEN
    INCR Picked%
    PRINT Picker$(i%); TAB(20 * (Picked% MOD 4));
      END IF
    NEXT i%
    PRINT : PRINT
    PRINT "You selected"; Picked%;
    IF Picked% = 1 THEN
      PRINT "animal."
    ELSE
      PRINT "animals."
    END IF
    PRINT
    COLOR 0
    PRINT "  Press Esc to return to the main menu, or any other key to display the multi-"
    PRINT "  pick pick list again (leaving the selected animals marked as selected)."
    KeyPressed$ = WAITKEY$
  LOOP UNTIL ASC(KeyPressed$) = 27
END SUB


SUB PickDemo LOCAL
  COLOR 0,7
  CLS
  PRINT "  A Pick List is a very powerful interface tool.  It allows you to present"
  PRINT "  a list of options to the user, reducing the typing the user must do.  They"
  PRINT "  can be used to select a database record, an option for an input field, or"
  PRINT "  any other situation where the user must pick one item from a list.  In"
  PRINT "  addition to the cursor keys, you can type a portion of a word in the list"
  PRINT "  and jump directly to that word.  Give it a try now:"
  DIM Box AS LOCAL WinAttr  ' create an instance of the WinAttr type for the pick list box
  Box.UR = 8    ' the upper corner of the box is at row 8, column 20
  Box.UC = 20
  Box.LR = 22   ' the lower row is 22; the width is sized dynamically
  Box.Style = 1     ' single line box frame
  Box.Title = 2     ' center title on the top line
  Box.Shade = 2
  Box.Shd = &H07    ' white on black shadow
  Box.Win = &H1F    ' bright white on blue interior
  Box.Frm = &H1E    ' yellow on blue frame
  Box.Ttl = &H1B    ' light cyan on blue title
  SortFlag% = 1         ' sort list in ascending order
  Title$ = "Animals"
  SScroll? = 1       ' show the scroll bar
  HighAttr? = &H71  ' blue on white highlight bar
  DO
    Selected% = PickListM%(Picker$(), SortFlag%, Box, Title$, SScroll?, HighAttr?)
    IF Selected% = -1 THEN EXIT LOOP
    LOCATE 25,3
    COLOR %BLUE, %WHITE
    PRINT "You selected "; Picker$(Selected%); SPACE$(20);
  LOOP
END SUB


SUB ScreenDemo LOCAL
  COLOR 0,7
  CLS
  LOCATE 3,1
  PRINT "  The Full Power Toolbox contains several routines that provide special"
  PRINT "  screen effects.  In this section of the demo, the screen will be"
  PRINT "  recolored, then a section of the screen will be cleared, and finally"
  PRINT "  another section of the screen will be filled with asterisks before"
  PRINT "  returning to the menu. When you are ready to proceed, please press"
  PRINT "  any key."
  WAITKEY$  ' wait for a keystroke
  ' recolor the screen
  Attr? = &H4F  ' change the screen to bright white on red
  CALL Recolor(Attr?)
  COLOR 15, 4
  CALL Line25("Press any key to continue.")
  WAITKEY$  ' wait for a keystroke
  ' clear a portion of the screen
  URow% = 1     ' clear the area from row 1, column 1
  LCol% = 1
  LRow% = 12    ' to row 12, column 80
  RCol% = 80
  Attr? = &H27  ' use white on green for the cleared section
  CALL PartialCLS(URow%, LCol%, LRow%, RCol%, Attr?)
  ' fill a different portion of the screen
  Char? = 42    ' asterisk
  Attr? = &H17  ' use white on blue
  DIM Coords AS LOCAL BoxSize   ' create an instance of the BoxSize type for the screen area
  Coords.UR = 13    ' fill the area from row 13, column 2
  Coords.UC = 2
  Coords.LR = 24    ' to row 24, column 80
  Coords.LC = 80
  CALL ScreenFill(Char?, Attr?, Coords)
  CALL Line25("Press any key to continue.")
  WAITKEY$  ' wait for a keystroke
END SUB


SUB WindowDemo LOCAL
  COLOR 0,7
  CLS
  PRINT "  The Full Power Toolbox contains powerful windowing routines with lots of"
  PRINT "  options.  You get complete control of colors, shadowing (8 types), title"
  PRINT "  position (8 types), and frame styles (20 types).  Here are a few samples:"
  DIM Box AS LOCAL WinAttr  ' create an instance of the WinAttr type for these example windows
  Title$ = "Demo"
  DIM Save&(1:8)    ' this array will hold the saved screens
  FOR c& = 1 TO 8   ' display 8 boxes on the screen
    IF c& < 5 THEN Box.UR = 6 ELSE Box.UR = 16
    Box.UC = (((c& - 1) MOD 4) * 19) + 4    ' this formula calculates the upper left column of the box
    Box.LR = Box.UR + 7
    Box.LC = Box.UC + 13
    Box.Style = c&
    Box.Title = c&
    Box.Shade = c&
    IF c& < 5 THEN Box.Shd = &H07 ELSE Box.Shd = &H70   ' set shadow attribute
    Box.Win = BuildAttr?((c& - 1), (c& - 1))
    Box.Frm = BuildAttr?(15, (c& - 1))   ' frame is bright white on the background color
    Box.Ttl = BuildAttr?(14, (c& - 1))   ' title is yellow on the background color
    CALL OpenWindow(Box, Title$, Save&(c&))
  NEXT c&
  ' now remove the windows
  LOCATE 25,1
  PRINT "Press any key to remove the boxes.";
  WAITKEY$  ' wait for a keystroke
  FOR c& = 8 TO 1 STEP -1
    CALL RestoreScreen(Save&(c&))
  NEXT c&
  ERASE Save&()         ' this array is no longer needed; reclaim the memory

  LOCATE 5,1
  PRINT "  You can also move a window around on the screen.  This program will"
  PRINT "  now draw a box on the screen and move it around at random until you"
  PRINT "  press the Esc key."
  Box.UR = 10       ' set up the moving box
  Box.UC = 30
  Box.LR = 18
  Box.LC = 45
  Box.Style = 1
  Box.Title = 2
  Box.Shade = 6
  Box.Shd = &H70
  Box.Win = &H47
  Box.Frm = &H4E
  Box.Ttl = &H4F
  Title$ = "Moving Box"
  Save2& = SaveScreen&
  CALL OpenWindow(Box, Title$, Save&)
  RANDOMIZE TIMER
  Length? = 1
  DO
    Buffer& = GlobalLock(Save2&)
    Temp$ = PEEK$(Buffer&, SCREENX * SCREENY * 4)
    GlobalUnlock Save2&
    Buffer& = GlobalLock(Save&)
    POKE$ Buffer&, Temp$
    GlobalUnlock Save&
    Direction? = INT(RND * 4)
    SELECT CASE Direction?
      CASE 0    ' left
        IF Box.UC < 5 THEN Direction? = 1
      CASE 1    ' right
        IF Box.LC > 75 THEN Direction? = 0
      CASE 2    ' up
        IF Box.UR < 3 THEN Direction? = 3
      CASE 3    ' down
        IF Box.LR > 22 THEN Direction? = 2
    END SELECT
    CALL FPMoveWindow(Box, Direction?, Length?, Save&)
    Save& = GlobalAlloc(%GMEM_FIXED, SCREENX * SCREENY * 4)
  LOOP UNTIL ASC(INKEY$) = 27

  Save& = GlobalFree(Save&) ' release the memory buffers
  Save2& = GlobalFree(Save2&)

END SUB
